<?php

/**
 * Field handler to provide simple renderer that allows linking to a node.
 */
class googlebase_views_handler_filter_feed extends views_handler_filter {

  function can_expose() { return FALSE; }

  /**
   * Add a type selector to the value form
   */
  function value_form(&$form, &$form_state) {
    parent::value_form($form, $form_state);
    $form['value'] = array(
      '#type' => 'radios',
      '#title' => t('Feed'),
      '#default_value' => empty($this->value) ? 'snippets' : $this->value,
      '#options' => array(
        'snippets' => t('Snippets Feed'),
        'items' => t('Items Feed'),
      ),
    );
    
  }

  /**
   * Add this filter to the query.
   *
   * Due to the nature of fapi, the value and the operator have an unintended
   * level of indirection. You will find them in $this->operator
   * and $this->value respectively.
   */
  function query() {
    if ($this->value == 'snippets') {
      $this->query->set_feed(GOOGLEBASE_SNIPPETS_FEED);
    }
    elseif ($this->value == 'items') {
      $this->query->set_feed(GOOGLEBASE_ITEMS_FEED);
    }
    
  }
}
