<?php

/**
 * Field handler to provide simple renderer that allows linking to a node.
 */
class googlebase_views_handler_filter_location extends views_handler_filter {
  var $no_single = TRUE;
  function option_definition() {
    $options = parent::option_definition();

    $options['operator']['default'] = 'optional';

    return $options;
  }

  /**
   * Provide simple equality operator
   */
  function operator_form(&$form, &$form_state) {
    parent::operator_form($form, $form_state);
    $form['operator'] = array(
      '#type' => 'radios',
      '#title' => t('On empty input'),
      '#default_value' => $this->operator,
      '#options' => array(
        'optional' => t('Show All'),
        'required' => t('Show None'),
      ),
    );
  }

  /**
   * Provide simple equality operator
   */
  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);

  }

  /**
   * Add a type selector to the value form
   */
  function value_form(&$form, &$form_state) {
    parent::value_form($form, $form_state);
    if (empty($form_state['exposed'])) {
      $form['value'] = array(
        '#title' => t('Location'),
        '#type' => 'textfield',
        '#size' => 25,
        '#default_value' => $this->value,
        '#attributes' => array('title' => t('Enter a location.')),
        '#description' => t('A location such as an address, city, or zip code.')
      );
    }

  }

  /**
   * Provide a location text field and optional distance field
   */
  function exposed_form(&$form, &$form_state) {
    parent::exposed_form($form, $form_state);
    if (isset($this->options['expose']['identifier'])) {
      $key = $this->options['expose']['identifier'];
      $form[$key] = array(
        '#type' => 'textfield',
        '#size' => 15,
        '#default_value' => $this->value,
        '#attributes' => array('title' => t('Enter a location.')),
        '#description' => t('A location such as an address, city, or zip code.')
      );
    }
  }

  /**
   * Validate the options form.
   */
  function exposed_validate($form, &$form_state) {
    //dpm($form);
  }

  /**
   * Add this filter to the query.
   *
   * Due to the nature of fapi, the value and the operator have an unintended
   * level of indirection. You will find them in $this->operator
   * and $this->value respectively.
   */
  function query() {
    if (!empty($this->value)) {
      // [location: @"San Francisco, CA, USA" + 3mi]
      $this->query->add_structure('location', '[location: @"' . $this->value . '"]');
    }
  }
}
